diff --git a/rtslib/target.py b/rtslib/target.py
index ac5e11c..19541f7 100644
--- a/rtslib/target.py
+++ b/rtslib/target.py
@@ -2,7 +2,7 @@
 Implements the RTS generic Target fabric classes.
 
 This file is part of RTSLib.
-Copyright (c) 2011-2013 by Datera, Inc
+Copyright (c) 2011-2014 by Datera, Inc
 
 Licensed under the Apache License, Version 2.0 (the "License"); you may
 not use this file except in compliance with the License. You may obtain
@@ -25,12 +25,14 @@ import shutil
 
 from node import CFSNode
 from os.path import isdir
-from doctest import testmod
 from configobj import ConfigObj
 from utils import RTSLibError, RTSLibBrokenLink, modprobe
 from utils import is_ipv6_address, is_ipv4_address
 from utils import fread, fwrite, generate_wwn, is_valid_wwn, exec_argv
 
+# Where do we store the fabric modules spec files ?
+spec_dir = "/var/target/fabric"
+
 class FabricModule(CFSNode):
     '''
     This is an interface to RTS Target Fabric Modules.
@@ -44,6 +46,14 @@ class FabricModule(CFSNode):
     discovery_auth_attributes = set(["discovery_auth"])
     target_names_excludes = version_attributes | discovery_auth_attributes
 
+    @classmethod
+    def all(cls):
+        mod_names = [mod_name[:-5] for mod_name in os.listdir(spec_dir)
+                     if mod_name.endswith('.spec')]
+        for name in mod_names:
+            yield FabricModule(name)
+
+
     # FabricModule private stuff
     def __init__(self, name):
         '''
@@ -53,8 +63,8 @@ class FabricModule(CFSNode):
         @type name: str
         '''
         super(FabricModule, self).__init__()
-        self.name = name
-        self.spec = self._parse_spec()
+        self.name = str(name)
+        self.spec = self._parse_spec("%s/%s.spec" % (spec_dir, name))
         self._path = "%s/%s" % (self.configfs_dir,
                                 self.spec['configfs_group'])
     # FabricModule public stuff
@@ -97,7 +107,7 @@ class FabricModule(CFSNode):
             yield ('create_cfs_group', self._fresh,
                    "Created '%s'." % self.path)
 
-    def _parse_spec(self):
+    def _parse_spec(self, spec_file):
         '''
         Parses the fabric module spec file.
         '''
@@ -112,7 +122,6 @@ class FabricModule(CFSNode):
                         wwn_from_cmds_filter='',
                         wwn_type='free')
 
-        spec_file = "%s/%s.spec" % (self.spec_dir, self.name)
         spec = ConfigObj(spec_file).dict()
         if spec:
             self.spec_file = spec_file
@@ -196,13 +205,10 @@ class FabricModule(CFSNode):
 
     def _list_targets(self):
         if self.exists:
-            return set(
-                [Target(self, wwn, 'lookup')
-                 for wwn in os.listdir(self.path)
-                 if os.path.isdir("%s/%s" % (self.path, wwn))
-                 if wwn not in self.target_names_excludes])
-        else:
-            return set([])
+            for wwn in os.listdir(self.path):
+                if os.path.isdir("%s/%s" % (self.path, wwn)) and \
+                        wwn not in self.target_names_excludes:
+                    yield Target(self, wwn, 'lookup')
 
     def _get_version(self):
         if self.exists:
@@ -313,7 +319,7 @@ class FabricModule(CFSNode):
         self._check_self()
         self._assert_feature('discovery_auth')
         path = "%s/discovery_auth/enforce_discovery_auth" % self.path
-        if enable:
+        if int(enable):
             enable = 1
         else:
             enable = 0
@@ -500,12 +506,15 @@ class LUN(CFSNode):
 
     def delete(self):
         '''
-        If the underlying configFS object does not exists, this method does
+        If the underlying configFS object does not exist, this method does
         nothing. If the underlying configFS object exists, this method attempts
         to delete it along with all MappedLUN objects referencing that LUN.
         '''
         self._check_self()
-        [mlun.delete() for mlun in self._list_mapped_luns()]
+
+        for mlun in self.mapped_luns:
+            mlun.delete()
+
         try:
             link = self.alias
         except RTSLibBrokenLink:
@@ -654,11 +663,7 @@ class MappedLUN(CFSNode):
     def _get_write_protect(self):
         self._check_self()
         path = "%s/write_protect" % self.path
-        write_protect = fread(path).strip()
-        if write_protect == "1":
-            return True
-        else:
-            return False
+        return bool(int(fread(path)))
 
     def _get_tpg_lun(self):
         self._check_self()
@@ -757,12 +762,9 @@ class NodeACL(CFSNode):
 
     def _list_mapped_luns(self):
         self._check_self()
-        mapped_luns = []
-        mapped_lun_dirs = glob.glob("%s/lun_*" % self.path)
-        for mapped_lun_dir in mapped_lun_dirs:
+        for mapped_lun_dir in glob.glob("%s/lun_*" % self.path):
             mapped_lun = int(os.path.basename(mapped_lun_dir).split("_")[1])
-            mapped_luns.append(MappedLUN(self, mapped_lun))
-        return mapped_luns
+            yield MappedLUN(self, mapped_lun)
 
     # NodeACL public stuff
     def has_feature(self, feature):
@@ -937,8 +939,8 @@ class TPG(CFSNode):
         except ValueError:
             raise RTSLibError("Invalid Tag.")
 
-        if tag < 1:
-            raise RTSLibError("Invalig Tag, it must be >0.")
+        if tag < 0:
+            raise RTSLibError("Invalig Tag, it must be 0 or more.")
 
         if isinstance(parent_target, Target):
             self._parent_target = parent_target
@@ -968,10 +970,9 @@ class TPG(CFSNode):
     def _list_network_portals(self):
         self._check_self()
         if not self.has_feature('nps'):
-            return []
-        network_portals = []
-        network_portal_dirs = os.listdir("%s/np" % self.path)
-        for network_portal_dir in network_portal_dirs:
+            return
+
+        for network_portal_dir in os.listdir("%s/np" % self.path):
             if network_portal_dir.startswith('['):
                 # IPv6 portals are [IPv6]:PORT
                 (ip_address, port) = \
@@ -982,9 +983,7 @@ class TPG(CFSNode):
                 (ip_address, port) = \
                         os.path.basename(network_portal_dir).split(":")
             port = int(port)
-            network_portals.append(
-                NetworkPortal(self, ip_address, port, 'lookup'))
-        return network_portals
+            yield NetworkPortal(self, ip_address, port, 'lookup')
 
     def _get_enable(self):
         self._check_self()
@@ -992,22 +991,22 @@ class TPG(CFSNode):
         # If the TPG does not have the enable attribute, then it is always
         # enabled.
         if os.path.isfile(path):
-            return int(fread(path))
+            return bool(int(fread(path)))
         else:
-            return 1
+            return True
 
     def _set_enable(self, boolean):
         '''
         Enables or disables the TPG. Raises an error if trying to disable a TPG
-        without en enable attribute (but enabling works in that case).
+        without an enable attribute (but enabling works in that case).
         '''
         self._check_self()
         path = "%s/enable" % self.path
-        if os.path.isfile(path):
-            if boolean and not self._get_enable():
-                fwrite(path, "1")
-            elif not boolean and self._get_enable():
-                fwrite(path, "0")
+        if os.path.isfile(path) and (boolean != self._get_enable()):
+            try:
+                fwrite(path, str(int(boolean)))
+            except IOError, e:
+                raise RTSLibError("Cannot change enable state: %s" % e)
         elif not boolean:
             raise RTSLibError("TPG cannot be disabled.")
 
@@ -1051,24 +1050,21 @@ class TPG(CFSNode):
     def _list_node_acls(self):
         self._check_self()
         if not self.has_feature('acls'):
-            return []
-        node_acls = []
+            return
+
         node_acl_dirs = [os.path.basename(path)
                          for path in os.listdir("%s/acls" % self.path)]
         for node_acl_dir in node_acl_dirs:
-            node_acls.append(NodeACL(self, node_acl_dir, 'lookup'))
-        return node_acls
+            yield NodeACL(self, node_acl_dir, 'lookup')
 
     def _list_luns(self):
         self._check_self()
-        luns = []
         lun_dirs = [os.path.basename(path)
                     for path in os.listdir("%s/lun" % self.path)]
         for lun_dir in lun_dirs:
             lun = lun_dir.split('_')[1]
             lun = int(lun)
-            luns.append(LUN(self, lun))
-        return luns
+            yield LUN(self, lun)
 
     def _control(self, command):
         self._check_self()
@@ -1132,6 +1128,14 @@ class TPG(CFSNode):
         self._check_self()
         return LUN(self, lun=lun, storage_object=storage_object, alias=alias)
 
+    def has_enable(self):
+        '''
+        Returns True if the TPG has the enable attribute, else False.
+        '''
+        self._check_self()
+        path = "%s/enable" % self.path
+        return os.path.isfile(path)
+
     alua_metadata_path = property(_get_alua_metadata_path,
                                   doc="Get the ALUA metadata directory path " \
                                   + "for the TPG.")
@@ -1210,13 +1214,10 @@ class Target(CFSNode):
 
     def _list_tpgs(self):
         self._check_self()
-        tpgs = []
-        tpg_dirs = glob.glob("%s/tpgt*" % self.path)
-        for tpg_dir in tpg_dirs:
+        for tpg_dir in glob.glob("%s/tpgt*" % self.path):
             tag = os.path.basename(tpg_dir).split('_')[1]
             tag = int(tag)
-            tpgs.append(TPG(self, tag, 'lookup'))
-        return tpgs
+            yield TPG(self, tag, 'lookup')
 
     # Target public stuff
 
@@ -1239,6 +1240,7 @@ class Target(CFSNode):
     tpgs = property(_list_tpgs, doc="Get the list of TPG for the Target.")
 
 def _test():
+    from doctest import testmod
     testmod()
 
 if __name__ == "__main__":
diff --git a/rtslib/tcm.py b/rtslib/tcm.py
index 1b1b8c3..85e9b9b 100644
--- a/rtslib/tcm.py
+++ b/rtslib/tcm.py
@@ -2,7 +2,7 @@
 Implements the RTS Target backstore and storage object classes.
 
 This file is part of RTSLib.
-Copyright (c) 2011-2013 by Datera, Inc
+Copyright (c) 2011-2014 by Datera, Inc
 
 Licensed under the Apache License, Version 2.0 (the "License"); you may
 not use this file except in compliance with the License. You may obtain
@@ -47,24 +47,17 @@ class Backstore(CFSNode):
                                         self._index)
         self._create_in_cfs_ine(mode)
 
-    def _get_plugin(self):
-        return self._plugin
-
     def _get_index(self):
         return self._index
 
     def _list_storage_objects(self):
         self._check_self()
-        storage_objects = []
         storage_object_names = [os.path.basename(s)
                                 for s in os.listdir(self.path)
                                 if s not in set(["hba_info", "hba_mode"])]
 
         for storage_object_name in storage_object_names:
-            storage_objects.append(self._storage_object_class(
-                self, storage_object_name))
-
-        return storage_objects
+            yield self._storage_object_class(self, storage_object_name)
 
     def _create_in_cfs_ine(self, mode):
         try:
@@ -113,8 +106,6 @@ class Backstore(CFSNode):
             doc="Get the list of StorageObjects attached to the backstore.")
     version = property(_get_version,
             doc="Get the Backstore plugin version string.")
-    plugin = property(_get_plugin,
-            doc="Get the Backstore plugin name.")
     name = property(_get_name,
             doc="Get the backstore name.")
 
@@ -170,39 +161,6 @@ class PSCSIBackstore(Backstore):
             doc="Get the legacy mode flag. If True, the Vitualbackstore "
                 + " index must match the StorageObjects real HBAs.")
 
-class RDDRBackstore(Backstore):
-    '''
-    This is an interface to rd_dr backstore plugin objects in configFS.
-    A RDDRBackstore object is identified by its backstore index.
-    '''
-
-    # RDDRBackstore private stuff
-
-    def __init__(self, index, mode='any'):
-        '''
-        @param index: The backstore index.
-        @type index: int
-        @param mode: An optionnal string containing the object creation mode:
-            - I{'any'} the configFS object will be either lookupd or created.
-            - I{'lookup'} the object MUST already exist configFS.
-            - I{'create'} the object must NOT already exist in configFS.
-        @type mode:string
-        @return: A RDDRBackstore object.
-        '''
-
-        super(RDDRBackstore, self).__init__("rd_dr", RDDRStorageObject,
-                                             index, mode)
-
-    # RDDRBackstore public stuff
-
-    def storage_object(self, name, size=None, gen_wwn=True):
-        '''
-        Same as RDDRStorageObject() without specifying the backstore
-        '''
-        self._check_self()
-        return RDDRStorageObject(self, name=name,
-                                 size=size, gen_wwn=gen_wwn)
-
 class RDMCPBackstore(Backstore):
     '''
     This is an interface to rd_mcp backstore plugin objects in configFS.
@@ -228,13 +186,13 @@ class RDMCPBackstore(Backstore):
 
     # RDMCPBackstore public stuff
 
-    def storage_object(self, name, size=None, gen_wwn=True):
+    def storage_object(self, name, size=None, gen_wwn=True, nullio=False):
         '''
         Same as RDMCPStorageObject() without specifying the backstore
         '''
         self._check_self()
-        return RDMCPStorageObject(self, name=name,
-                                  size=size, gen_wwn=gen_wwn)
+        return RDMCPStorageObject(self, name=name, size=size,
+                                  gen_wwn=gen_wwn, nullio=nullio)
 
 class FileIOBackstore(Backstore):
     '''
@@ -420,13 +378,11 @@ class StorageObject(CFSNode):
 
     def _list_attached_luns(self):
         '''
-        Just returns a set of all luns attached to a storage object.
+        Generates all luns attached to a storage object.
         '''
         self._check_self()
-        luns = set([])
         for lun in self._gen_attached_luns():
-            luns.add(lun)
-        return luns
+            yield lun
 
     # StorageObject public stuff
 
@@ -472,7 +428,7 @@ class StorageObject(CFSNode):
     wwn = property(_get_wwn, _set_wwn,
             doc="Get or set the StorageObject T10 WWN Serial as a string.")
     status = property(_get_status,
-            doc="Get the storage object status, depending on wether or not it"\
+            doc="Get the storage object status, depending on whether or not it"\
                 + "is used by any LUN")
     attached_luns = property(_list_attached_luns,
             doc="Get the list of all LUN objects attached.")
@@ -656,97 +612,6 @@ class PSCSIStorageObject(StorageObject):
     lun = property(_get_lun,
             doc="Get the SCSI device LUN")
 
-class RDDRStorageObject(StorageObject):
-    '''
-    An interface to configFS storage objects for rd_dr backstore.
-    '''
-
-    # RDDRStorageObject private stuff
-
-    def __init__(self, backstore, name, size=None, gen_wwn=True):
-        '''
-        A RDDRStorageObject can be instantiated in two ways:
-            - B{Creation mode}: If I{size} is specified, the underlying
-              configFS object will be created with that parameter.
-              No RDDRStorageObject with the same I{name} can pre-exist in the
-              parent RDDRBackstore in that mode, or instantiation will fail.
-            - B{Lookup mode}: If I{size} is not set, then the RDDRStorageObject
-              will be bound to the existing configFS object in the parent
-              RDDRBackstore having the specified I{name}.
-              The underlying configFS object must already exist in that mode,
-              or instantiation will fail.
-
-        @param backstore: The parent backstore of the RDDRStorageObject.
-        @type backstore: RDDRBackstore
-        @param name: The name of the RDDRStorageObject.
-        @type name: string
-        @param size: The size of the ramdrive to create:
-            - If size is an int, it represents a number of bytes
-            - If size is a string, the following units can be used :
-                - I{B} or no unit present for bytes
-                - I{k}, I{K}, I{kB}, I{KB} for kB (kilobytes)
-                - I{m}, I{M}, I{mB}, I{MB} for MB (megabytes)
-                - I{g}, I{G}, I{gB}, I{GB} for GB (gigabytes)
-                - I{t}, I{T}, I{tB}, I{TB} for TB (terabytes)
-                Example: size="1MB" for a one megabytes storage object.
-                - Note that the size will be rounded to the closest 4096 Bytes
-                  RAM pages count. For instance, a size of 100000 Bytes will be
-                  rounded to 24 pages, really 98304 Bytes.
-                - The base value for kilo is 1024, aka 1kB = 1024B.
-                  Strictly speaking, we use kiB, MiB, etc.
-        @type size: string or int
-        @param gen_wwn: Should we generate a T10 WWN Unit Serial ?
-        @type gen_wwn: bool
-        @return: A RDDRStorageObject object.
-        '''
-
-        if size is not None:
-            super(RDDRStorageObject, self).__init__(backstore, RDDRBackstore,
-                                                    name, 'create')
-            try:
-                self._configure(size, gen_wwn)
-            except:
-                self.delete()
-                raise
-        else:
-            super(RDDRStorageObject, self).__init__(backstore, RDDRBackstore,
-                                                    name, 'lookup')
-
-    def _configure(self, size, wwn):
-        self._check_self()
-        size = convert_human_to_bytes(size)
-        # convert to 4k pages
-        size = round(float(size)/4096)
-        if size == 0:
-            size = 1
-
-        self._control("rd_pages=%d" % size)
-        self._enable()
-        if wwn:
-            self.wwn = generate_wwn('unit_serial')
-
-    def _get_page_size(self):
-        self._check_self()
-        return int(self._parse_info("PAGES/PAGE_SIZE").split('*')[1])
-
-    def _get_pages(self):
-        self._check_self()
-        return int(self._parse_info("PAGES/PAGE_SIZE").split('*')[0])
-
-    def _get_size(self):
-        self._check_self()
-        size = self._get_page_size() * self._get_pages()
-        return size
-
-    # RDDRStorageObject public stuff
-
-    page_size = property(_get_page_size,
-            doc="Get the ramdisk page size.")
-    pages = property(_get_pages,
-            doc="Get the ramdisk number of pages.")
-    size = property(_get_size,
-            doc="Get the ramdisk size in bytes.")
-
 class RDMCPStorageObject(StorageObject):
     '''
     An interface to configFS storage objects for rd_mcp backstore.
@@ -754,7 +619,7 @@ class RDMCPStorageObject(StorageObject):
 
     # RDMCPStorageObject private stuff
 
-    def __init__(self, backstore, name, size=None, gen_wwn=True):
+    def __init__(self, backstore, name, size=None, gen_wwn=True, nullio=False):
         '''
         A RDMCPStorageObject can be instantiated in two ways:
             - B{Creation mode}: If I{size} is specified, the underlying
@@ -788,16 +653,17 @@ class RDMCPStorageObject(StorageObject):
         @type size: string or int
         @param gen_wwn: Should we generate a T10 WWN Unit Serial ?
         @type gen_wwn: bool
+        @param nullio: If rd should be created w/o backing page store.
+        @type nullio: bool
         @return: A RDMCPStorageObject object.
         '''
-
         if size is not None:
             super(RDMCPStorageObject, self).__init__(backstore,
                                                      RDMCPBackstore,
                                                      name,
                                                      'create')
             try:
-                self._configure(size, gen_wwn)
+                self._configure(size, gen_wwn, nullio)
             except:
                 self.delete()
                 raise
@@ -807,7 +673,7 @@ class RDMCPStorageObject(StorageObject):
                                                      name,
                                                      'lookup')
 
-    def _configure(self, size, wwn):
+    def _configure(self, size, wwn, nullio):
         self._check_self()
         size = convert_human_to_bytes(size)
         # convert to 4k pages
@@ -816,6 +682,8 @@ class RDMCPStorageObject(StorageObject):
             size = 1
 
         self._control("rd_pages=%d" % size)
+        if nullio:
+            self._control("rd_nullio=1")
         self._enable()
         if wwn:
             self.wwn = generate_wwn('unit_serial')
@@ -833,6 +701,14 @@ class RDMCPStorageObject(StorageObject):
         size = self._get_page_size() * self._get_pages()
         return size
 
+    def _get_nullio(self):
+        self._check_self()
+        # nullio not present before 3.10
+        try:
+            return bool(int(self._parse_info('nullio')))
+        except AttributeError:
+            return False
+
     # RDMCPStorageObject public stuff
 
     page_size = property(_get_page_size,
@@ -841,7 +717,8 @@ class RDMCPStorageObject(StorageObject):
             doc="Get the ramdisk number of pages.")
     size = property(_get_size,
             doc="Get the ramdisk size in bytes.")
-
+    nullio = property(_get_nullio,
+            doc="Get the nullio status.")
 
 class FileIOStorageObject(StorageObject):
     '''
@@ -949,7 +826,6 @@ class FileIOStorageObject(StorageObject):
                                   + "%s is already in use." % dev)
             if is_disk_partition(rdev):
                 size = get_disk_size(rdev)
-                print "fd_dev_name=%s,fd_dev_size=%d" % (dev, size)
                 self._control("fd_dev_name=%s,fd_dev_size=%d" % (dev, size))
             else:
                 self._control("fd_dev_name=%s" % dev)
diff --git a/rtslib/utils.py b/rtslib/utils.py
index 5dcaeda..dbd6364 100644
--- a/rtslib/utils.py
+++ b/rtslib/utils.py
@@ -2,7 +2,7 @@
 Provides various utility functions.
 
 This file is part of RTSLib.
-Copyright (c) 2011-2013 by Datera, Inc
+Copyright (c) 2011-2014 by Datera, Inc
 
 Licensed under the Apache License, Version 2.0 (the "License"); you may
 not use this file except in compliance with the License. You may obtain
@@ -49,42 +49,15 @@ class RTSLibNotInCFS(RTSLibError):
     '''
     The underlying configfs object does not exist. Happens when
     calling methods of an object that is instantiated but have
-    been deleted from congifs, or when trying to lookup an
+    been deleted from configs, or when trying to lookup an
     object that does not exist.
     '''
     pass
 
-def flatten_nested_list(nested_list):
-    '''
-    Function to flatten a nested list.
-
-    >>> import rtslib.utils as utils
-    >>> utils.flatten_nested_list([[1,2,3,[4,5,6]],[7,8],[[[9,10]],[11,]]])
-    [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11]
-
-    @param nested_list: A nested list (list of lists of lists etc.)
-    @type nested_list: list
-    @return: A list with only non-list elements
-    '''
-    return list(gen_list_item(nested_list))
-
-def gen_list_item(nested_list):
-    '''
-    The generator for flatten_nested_list().
-    It returns one by one items that are not a list, and recurses when
-    he finds an item that is a list.
-    '''
-    for item in nested_list:
-        if type(item) is list:
-            for nested_item in gen_list_item(item):
-                yield nested_item
-        else:
-            yield item
-
 def fwrite(path, string):
     '''
     This function writes a string to a file, and takes care of
-    opening it and closing it. If the file does not exists, it
+    opening it and closing it. If the file does not exist, it
     will be created.
 
     >>> from rtslib.utils import *
@@ -352,6 +325,7 @@ def get_block_type(path):
                               161,  # Carmel 8-port SATA Disks
                               199,  # Veritas volume manager (VxVM) volumes
                               201,  # Veritas VxVM dynamic multipathing driver
+                              202,  # Xen block device
                               230,  # ZFS ZVols
                               240,  # LOCAL/EXPERIMENTAL USE
                               241,  # LOCAL/EXPERIMENTAL USE
@@ -471,6 +445,14 @@ def convert_scsi_hctl_to_path(host, controller, target, lun):
             return os.path.realpath(path)
     return ''
 
+def convert_bytes_to_human(size):
+    if not size:
+        return ""
+    for x in ['bytes','K','M','G','T']:
+        if size < 1024.0:
+            return "(%3.1f%s) " % (size, x)
+        size /= 1024.0
+
 def convert_human_to_bytes(hsize, kilo=1024):
     '''
     This function converts human-readable amounts of bytes to bytes.
@@ -621,7 +603,7 @@ def modprobe(module):
             else:
                 return True
         else:
-            raise RTSLibError("Kernel module %s does not exists on disk "
+            raise RTSLibError("Kernel module %s does not exist on disk "
                                   % module + "and is not loaded.")
     else:
         return False
diff --git a/setup.py b/setup.py
index ebb22ad..34e5dfc 100755
--- a/setup.py
+++ b/setup.py
@@ -1,7 +1,7 @@
 #! /usr/bin/env python
 '''
 This file is part of RTSLib.
-Copyright (c) 2011-2013 by Datera, Inc
+Copyright (c) 2011-2014 by Datera, Inc
 
 Licensed under the Apache License, Version 2.0 (the "License"); you may
 not use this file except in compliance with the License. You may obtain
diff --git a/specs/ib_srpt.spec b/specs/ib_srpt.spec
index 958322d..1496b1a 100644
--- a/specs/ib_srpt.spec
+++ b/specs/ib_srpt.spec
@@ -10,7 +10,7 @@ kernel_module = ib_srpt
 # The module uses hardware addresses from there
 wwn_from_files = /sys/class/infiniband/*/ports/*/gids/0
 # Transform 'fe80:0000:0000:0000:0002:1903:000e:8acd' WWN notation to
-# '0x00000000000000000002c903000e8acd'
+# '0xfe800000000000000002c903000e8acd'
 wwn_from_files_filter = "sed -e s/fe80/0xfe80/ -e 's/\://g'"
 
 # The configfs group
diff --git a/specs/usb_gadget.spec b/specs/usb_gadget.spec
new file mode 100644
index 0000000..43506db
--- /dev/null
+++ b/specs/usb_gadget.spec
@@ -0,0 +1,4 @@
+features = nexus
+wwn_type = naa
+kernel_module = tcm_usb_gadget
+configfs_group = "usb_gadget"
diff --git a/specs/vhost.spec b/specs/vhost.spec
index ee7c516..5e50601 100644
--- a/specs/vhost.spec
+++ b/specs/vhost.spec
@@ -5,7 +5,7 @@ features = nexus, tpgts
 wwn_type = naa
 
 # Non-standard module naming scheme
-kernel_module = tcm_vhost
+kernel_module = vhost_scsi
 
 # The configfs group
 configfs_group = vhost
diff --git a/tests/data/config_attribute_group.ast b/tests/data/config_attribute_group.ast
new file mode 100644
index 0000000..1cc53f1
--- /dev/null
+++ b/tests/data/config_attribute_group.ast
@@ -0,0 +1,100 @@
+(lp0
+(lp1
+(dp2
+S'line'
+p3
+I1
+sS'type'
+p4
+S'obj'
+p5
+sS'col'
+p6
+I1
+sS'key'
+p7
+(S'storage'
+p8
+S'fileio'
+p9
+tp10
+sa(dp11
+g3
+I1
+sg4
+g5
+sg6
+I16
+sg7
+(S'disk'
+p12
+S'vm1'
+p13
+tp14
+sa(dp15
+S'statements'
+p16
+(lp17
+(lp18
+(dp19
+g3
+I2
+sg4
+S'attr'
+p20
+sg6
+I5
+sg7
+(S'path'
+p21
+S'/tmp/vm1.img'
+p22
+tp23
+saa(lp24
+(dp25
+g3
+I3
+sg4
+g20
+sg6
+I5
+sg7
+(S'size'
+p26
+S'1MB'
+p27
+tp28
+saa(lp29
+(dp30
+g3
+I4
+sg4
+S'group'
+p31
+sg6
+I5
+sg7
+(S'attribute'
+p32
+tp33
+sa(dp34
+g3
+I4
+sg4
+g20
+sg6
+I15
+sg7
+(S'block_size'
+p35
+S'512'
+p36
+tp37
+saasg3
+I1
+sg4
+S'block'
+p38
+sg6
+I25
+saa.
\ No newline at end of file
diff --git a/tests/data/config_attribute_group.lio b/tests/data/config_attribute_group.lio
new file mode 100644
index 0000000..aae8c5d
--- /dev/null
+++ b/tests/data/config_attribute_group.lio
@@ -0,0 +1,5 @@
+storage fileio disk vm1 {
+    path /tmp/vm1.img
+    size 1MB
+    attribute block_size 512
+}
diff --git a/tests/data/config_basic.ast b/tests/data/config_basic.ast
new file mode 100644
index 0000000..fb02d66
--- /dev/null
+++ b/tests/data/config_basic.ast
@@ -0,0 +1,74 @@
+(lp0
+(lp1
+(dp2
+S'line'
+p3
+I1
+sS'type'
+p4
+S'obj'
+p5
+sS'col'
+p6
+I1
+sS'key'
+p7
+(S'storage'
+p8
+S'fileio'
+p9
+tp10
+sa(dp11
+g3
+I1
+sg4
+g5
+sg6
+I16
+sg7
+(S'disk'
+p12
+S'vm1'
+p13
+tp14
+sa(dp15
+S'statements'
+p16
+(lp17
+(lp18
+(dp19
+g3
+I2
+sg4
+S'attr'
+p20
+sg6
+I5
+sg7
+(S'path'
+p21
+S'/tmp/vm1.img'
+p22
+tp23
+saa(lp24
+(dp25
+g3
+I3
+sg4
+g20
+sg6
+I5
+sg7
+(S'size'
+p26
+S'1MB'
+p27
+tp28
+saasg3
+I1
+sg4
+S'block'
+p29
+sg6
+I25
+saa.
\ No newline at end of file
diff --git a/tests/data/config_basic.lio b/tests/data/config_basic.lio
new file mode 100644
index 0000000..e27b8ae
--- /dev/null
+++ b/tests/data/config_basic.lio
@@ -0,0 +1,4 @@
+storage fileio disk vm1 {
+    path /tmp/vm1.img
+    size 1MB
+}
diff --git a/tests/data/config_comments.ast b/tests/data/config_comments.ast
new file mode 100644
index 0000000..dc35bc6
--- /dev/null
+++ b/tests/data/config_comments.ast
@@ -0,0 +1,228 @@
+(lp0
+(lp1
+(dp2
+S'line'
+p3
+I2
+sS'type'
+p4
+S'obj'
+p5
+sS'col'
+p6
+I1
+sS'key'
+p7
+(S'storage'
+p8
+S'fileio'
+p9
+tp10
+sa(dp11
+S'statements'
+p12
+(lp13
+(lp14
+(dp15
+g3
+I3
+sg4
+g5
+sg6
+I5
+sg7
+(S'disk'
+p16
+S'vm1'
+p17
+tp18
+sa(dp19
+g12
+(lp20
+(lp21
+(dp22
+g3
+I4
+sg4
+S'attr'
+p23
+sg6
+I9
+sg7
+(S'path'
+p24
+S'/tmp/disk1.img'
+p25
+tp26
+saa(lp27
+(dp28
+g3
+I5
+sg4
+g23
+sg6
+I9
+sg7
+(S'size'
+p29
+S'1MB'
+p30
+tp31
+saa(lp32
+(dp33
+g3
+I7
+sg4
+S'group'
+p34
+sg6
+I9
+sg7
+(S'attribute'
+p35
+tp36
+sa(dp37
+g12
+(lp38
+(lp39
+(dp40
+g3
+I9
+sg4
+g23
+sg6
+I13
+sg7
+(S'block_size'
+p41
+S'512'
+p42
+tp43
+saa(lp44
+(dp45
+g3
+I10
+sg4
+g23
+sg6
+I13
+sg7
+(S'optimal_sectors'
+p46
+S'1024'
+p47
+tp48
+saa(lp49
+(dp50
+g3
+I11
+sg4
+g23
+sg6
+I13
+sg7
+(S'queue_depth'
+p51
+S'32'
+p52
+tp53
+saa(lp54
+(dp55
+g3
+I13
+sg4
+g23
+sg6
+I13
+sg7
+(S'emulate_tas'
+p56
+S'yes'
+p57
+tp58
+saa(lp59
+(dp60
+S'comment'
+p61
+S'EOL comment'
+p62
+sg3
+I14
+sg4
+g23
+sg6
+I13
+sg7
+(S'enforce_pr_isids'
+p63
+S'yes'
+p64
+tp65
+saa(lp66
+(dp67
+g3
+I16
+sg4
+g23
+sg6
+I13
+sg7
+(S'emulate_dpo'
+p68
+S'no'
+p69
+tp70
+saa(lp71
+(dp72
+g61
+S'Hello there!'
+p73
+sg3
+I17
+sg4
+g23
+sg6
+I13
+sg7
+(S'emulate_tpu'
+p74
+S'no'
+p75
+tp76
+saa(lp77
+(dp78
+g61
+S'Does what it says?'
+p79
+sg3
+I18
+sg4
+g23
+sg6
+I13
+sg7
+(S'is_nonrot'
+p80
+S'no'
+p81
+tp82
+saasg3
+I7
+sg4
+S'block'
+p83
+sg6
+I19
+saasg3
+I3
+sg4
+g83
+sg6
+I14
+saasg3
+I2
+sg4
+g83
+sg6
+I16
+saa.
\ No newline at end of file
diff --git a/tests/data/config_comments.lio b/tests/data/config_comments.lio
new file mode 100644
index 0000000..89a09c9
--- /dev/null
+++ b/tests/data/config_comments.lio
@@ -0,0 +1,23 @@
+# This is a comment before the first statement
+storage fileio {
+    disk vm1 {
+        path /tmp/disk1.img
+        size 1MB
+        # This is an indented comment after size and before a group
+        attribute {
+            # This is an indented comment after a group
+            block_size 512
+            optimal_sectors 1024
+            queue_depth 32
+
+            emulate_tas yes
+            enforce_pr_isids yes # EOL comment
+
+            emulate_dpo no
+            emulate_tpu no  # Hello there!
+            is_nonrot no  # Does what it says?
+        }
+    }
+}
+
+# Last words comment
